%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                                %
% endliche Automaten                                                             %
% Die Abbildung des Automaten finden Sie auf Folie 26.                           %
% Repraesentieren Sie diesen Automaten in Prolog und schreiben Sie ein Praedikat %
% fsa_accept/1, das als Argument eine Liste nimmt und gelingt, wenn die Liste    %
% eine von dem Automaten akzeptierte Sequenz ist.                                %
%                                                                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Die Abbildung des Automaten finden Sie auf Folie 26.
% Repraesentieren Sie diesen Automaten in Prolog und schreiben Sie ein Praedikat
% fsa_accept/1, das als Argument eine Liste nimmt und gelingt, wenn die Liste
% eine von dem Automaten akzeptierte Sequenz ist.

%%% Loesung

fsa_accept(L) :- start_fsa(In),             % Der FSA akzeptiert die eingegebene Liste, wenn die erste Eingabe der Startzustand ist und
                 fsa(L,In).                 % wenn die Listeineingabe mit den vorhandenen Kanten und Eingaben übereinstimmt.

fsa([],Q) :- end_fsa(Q).                    % Wenn keine Eingabe mehr erfolgt, muss man sich im Endzustand befinden. 

% Es muss einen Übergang für X von Q1 zu Q2 geben, sodass dieses gelesen und als Head des Wortes gespeichert werden kann.
% Am Ende des Lesens muss man sich im zweiten Zustand (Q2) befinden, die Eingabe wird in W gespeichert. 

fsa([X|W],Q1) :- kante_fsa(Q1,X,Q2),        % Die Eingabe kann gelesen werden, wenn es einen passenden Übergang für die Eingabe gibt und
                 fsa(W,Q2).                 % die bereits gelesene Eingabe wird in W gespeichert.


start_fsa(q0).                              % einzige mögliche Startzustand, q0

end_fsa(q0).                                % einzige mögliche Endzustand, q0

% Aufzählung aller möglichen Übergänge, sowie Eingaben: 

kante_fsa(q0,a,q1).                         % Übergang von q0 zu q1, a wird gelesen
kante_fsa(q0,b,q0).                         % Übergang von q0 zu q1, b wird gelesen
kante_fsa(q1,a,q0).                         % Übergang von q1 zu q0, a wird gelesen
kante_fsa(q1,b,q1).                         % Übergang von q1 zu q1, b wird gelesen
