%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                               %
% endliche Transduktoren                                                        %
%                                                                               %
% Repräsentiere diesen Automaten in Prolog und schreibe                         %2
% ein Prädikat trans_accept/1, das als Argumente Listenpaare nimmt und gelingt, %
% wenn das Listenpaar von dem Transduktor akzeptiert wird.                      %
%                                                                               %    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%% Lösung

trans_accept(L1,L2) :- start_trans(In),                         % Der Automat akzeptiert L1 und L2, wenn man sich in einem
                                                                % Startzustand befindet und
                       trans(L1,L2,In).                         % wenn L1 und L2 eingelesen werden können. 
                       
trans([],[],Q) :- end_trans(Q).                                 % erfolgt keine Eingabe durch beide Listen mehr, 
                                                                % muss man sich in einem Endzustand befinden

trans([S1|W1],[S2|W2],Q1) :- kante_trans(Q1,S1,S2,Q2),          % Die Sequenz kann gelesen werden, wenn es einen Übergang
                                                                % von Q1 zu Q2 gibt und S1 und S2 gelesen werden und
                             trans(W1,W2,Q2).                   % man sich nach dem Lesen im Zustand Q2 befindet.
                       
start_trans(q0).                                                % q0 wird als Startzustand festgelegt

end_trans(q0).                                                  % q0 wird als Endzustand festgelegt
end_trans(q1).                                                  % q1 wird als Endzustand festgelegt

kante_trans(q0,a,a,q1).                                         % Übergang von q0 zu q1, a, a wird gelesen
kante_trans(q0,b,b,q0).                                         % Übergang von q0 zu q1, b, b wird gelesen
kante_trans(q1,a,b,q0).                                         % Übergang von q1 zu q0, a, b wird gelesen
kante_trans(q1,b,b,q1).                                         % Übergang von q1 zu q1, b, b wird gelesen
                       

